#
# TODO: - rewrite generate-tarball.sh script to provide locales.zip handling (if needed)
#	- make separate server package with init-scripts, etc...
#	- -locales.patch needs love
#
# NOTE:
# Upstream packages some unfree fonts which we cannot redistribute,
# so when upgrading calibre we should download upstream tarball by hand from
# http://downloads.sourceforge.net/calibre and run generate-tarball.sh script
# included as SourceX.
#
Summary:	E-book converter and library management
Summary(pl.UTF-8):	Konwerter oraz biblioteka dla e-booków
Name:		calibre
Version:	1.15.0
Release:	2
License:	GPL v3+
Group:		Applications/Multimedia
Source0:	%{name}-%{version}-nofonts.tar.xz
# Source0-md5:	f1394951cc8675b37435575ec302aff6
Source1:	generate-tarball.sh
Source2:	%{name}-mount-helper
Patch0:		%{name}-prefix.patch
Patch1:		%{name}-no-update.patch
Patch2:		%{name}-env_module.patch
Patch3:		%{name}-locales.patch
Patch4:		shebang-python-fix.patch
Patch5:		imagemagick-6.8.patch
Patch6:		qt4-private.patch
URL:		http://www.calibre-ebook.com/
%define		baeutifulsoup_ver 3.0.5
%define		pil_ver 1.1.6
%define		pyqt4_ver 4.9.1
%define		apsw_ver 3.8.0.1
%define		cssselect_ver 0.7.1
%define		cssutils_ver 1:0.9.9
%define		dateutil_ver 1.4.1
%define		dns_ver 1.6.0
%define		lxml_ver 2.2.1
%define		mechanize_ver 0.1.11
%define		netifaces_ver 0.8
%define		psutil_ver 0.6.1
BuildRequires:	ImageMagick-devel >= 6.6.4.7
BuildRequires:	QtCore-devel
BuildRequires:	QtDBus-devel
BuildRequires:	QtGui-devel
BuildRequires:	QtSvg-devel
BuildRequires:	chmlib-devel >= 0.40
BuildRequires:	libicu-devel
BuildRequires:	libmtp-devel >= 1.1.5
BuildRequires:	libwmf-devel >= 0.2.8
BuildRequires:	pkgconfig
BuildRequires:	podofo-devel >= 0.8.2
BuildRequires:	poppler-Qt-devel >= 0.20.2
BuildRequires:	poppler-glib-devel >= 0.20.2
BuildRequires:	python-BeautifulSoup >= %{baeutifulsoup_ver}
BuildRequires:	python-PIL >= %{pil_ver}
BuildRequires:	python-PyQt4 >= %{pyqt4_ver}
BuildRequires:	python-PyQt4-devel >= %{pyqt4_ver}
BuildRequires:	python-PyQt4-devel-tools >= %{pyqt4_ver}
BuildRequires:	python-apsw >= %{apsw_ver}
BuildRequires:	python-cssselect >= %{cssselect_ver}
BuildRequires:	python-cssutils >= %{cssutils_ver}
BuildRequires:	python-dateutil >= %{dateutil_ver}
BuildRequires:	python-devel >= 1:2.7.1
BuildRequires:	python-dns >= %{dns_ver}
BuildRequires:	python-genshi
BuildRequires:	python-lxml >= %{lxml_ver}
BuildRequires:	python-mechanize >= %{mechanize_ver}
BuildRequires:	python-modules-sqlite
BuildRequires:	python-netifaces >= %{netifaces_ver}
BuildRequires:	python-psutil >= %{psutil_ver}
BuildRequires:	python-sip-devel
BuildRequires:	qt4-devel-private
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.586
BuildRequires:	sed >= 4.0
BuildRequires:	sqlite3-devel
BuildRequires:	tar >= 1:1.22
BuildRequires:	unzip
BuildRequires:	xdg-utils
BuildRequires:	xz >= 1:4.999.7
Requires:	python-BeautifulSoup >= %{baeutifulsoup_ver}
Requires:	python-PIL >= %{pil_ver}
Requires:	python-PyQt4 >= %{pyqt4_ver}
Requires:	python-apsw >= %{apsw_ver}
Requires:	python-cssselect >= %{cssselect_ver}
Requires:	python-cssutils >= %{cssutils_ver}
Requires:	python-dateutil >= %{dateutil_ver}
Requires:	python-dns >= %{dns_ver}
Requires:	python-genshi
Requires:	python-lxml >= %{lxml_ver}
Requires:	python-mechanize >= %{mechanize_ver}
Requires:	python-modules-sqlite
Requires:	python-netifaces >= %{netifaces_ver}
Requires:	python-psutil >= %{psutil_ver}
Suggests:	ImageMagick-coder-jpeg
Suggests:	ImageMagick-coder-png
### FIXME: libunrar.so is needed for rar-packed files
Suggests:	libunrar-devel
Suggests:	poppler-progs
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Calibre is meant to be a complete e-library solution. It includes
library management, format conversion, news feeds to ebook conversion
as well as e-book reader sync features.

Calibre is primarily a ebook cataloging program. It manages your ebook
collection for you. It is designed around the concept of the logical
book, i.e. a single entry in the database that may correspond to
ebooks in several formats. It also supports conversion to and from a
dozen different ebook formats.

Supported input formats are: MOBI, LIT, PRC, EPUB, CHM, ODT, HTML,
CBR, CBZ, RTF, TXT, PDF and LRS.

%description -l pl.UTF-8
Calibre to bardzo dobry i darmowy program do czytania e-książek.

Calibre umożliwia zarówno czytanie e-książek jak i konwersję wielu
formatów do ich postaci. Program obsługuje następujące typy plików:
import: LRF, PDF, LIT, RTF, OPF, MOBI, PRC, EPUB, FB2, IMP, RB i HTML
eksport: Mobi, LRF i EPUB oraz do aplikacji iPhone-reader i Stanza.

Ten czytnik e-książek oferuje również pobieranie okładek, komiksów i
najnowszych wiadomości z serwisów poświęconym e-książkom. Twórcy
dołączyli również aplikację, którą użytkownik może wykorzystać jako
swój własny serwer darmowych książek.

%package -n bash-completion-calibre
Summary:	bash-completion for calibre
Summary(pl.UTF-8):	bashowe uzupełnianie nazw dla calibre
Group:		Applications/Shells
Requires:	%{name} = %{version}-%{release}
Requires:	bash-completion

%description -n bash-completion-calibre
bash-completion for calibre.

%description -n bash-completion-calibre -l pl.UTF-8
Pakiet ten dostarcza bashowe uzupełnianie nazw dla calibre.

%package -n zsh-completion-calibre
Summary:	zsh-completion for calibre
Summary(pl.UTF-8):	uzupełnianie nazw dla calibre w powłoce zsh
Group:		Applications/Shells
Requires:	%{name} = %{version}-%{release}
Requires:	bash-completion

%description -n zsh-completion-calibre
zsh-completion for calibre.

%description -n zsh-completion-calibre -l pl.UTF-8
Pakiet ten dostarcza uzupełnianie nazw dla calibre w powłoce zsh.

%prep
%setup -q -n %{name}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
#patch5 -p1
%patch6 -p1

# 64bit target build fix
%{__sed} -i -e "s!'/usr/lib'!'%{_libdir}'!g" setup/build_environment.py

# upstream decides to store locale files in a single zip file but we prefer separate .mo
mkdir resources/localization/locales
unzip resources/localization/locales.zip -d resources/localization/locales
chmod 755 resources/localization/locales/*
rm -f resources/localization/locales.zip

%build
CC="%{__cc}" \
CXX=%{__cxx} \
OVERRIDE_CFLAGS="%{rpmcflags}" \
OVERRIDE_LDFLAGS="%{rpmldflags}" \
%{__python} setup.py build

%install
rm -rf $RPM_BUILD_ROOT
# create directories for xdg-utils
install -d $RPM_BUILD_ROOT%{_datadir}/{icons/hicolor,packages,mime/packages,desktop-directories} \
	$RPM_BUILD_ROOT{%{_desktopdir},%{_pixmapsdir},/usr/share/zsh/site-functions}

XDG_DATA_DIRS="$RPM_BUILD_ROOT%{_datadir}" \
XDG_UTILS_INSTALL_MODE="system" \
LIBPATH="%{_libdir}" \
%{__python} setup.py install \
	--root=$RPM_BUILD_ROOT \
	--libdir="%{_libdir}"

cp -p resources/images/library.png $RPM_BUILD_ROOT%{_pixmapsdir}/%{name}-gui.png
cp -p resources/images/viewer.png $RPM_BUILD_ROOT%{_pixmapsdir}/calibre-viewer.png

%py_ocomp $RPM_BUILD_ROOT%{_libdir}/%{name}
%py_comp $RPM_BUILD_ROOT%{_libdir}/%{name}
%py_postclean %{_libdir}/%{name}

mv $RPM_BUILD_ROOT%{_datadir}/%{name}/localization/locales $RPM_BUILD_ROOT%{_localedir}

# set proper filenames for locales (TODO: switch to patch if possible)
for file in $RPM_BUILD_ROOT%{_localedir}/*; do
	lang=$(echo $file|%{__sed} 's:.*locale/\(.*\).*:\1:')
	mkdir $RPM_BUILD_ROOT%{_localedir}/$lang/LC_MESSAGES
	mv $RPM_BUILD_ROOT%{_localedir}/$lang/*.mo \
	$RPM_BUILD_ROOT%{_localedir}/$lang/LC_MESSAGES
done;
for file in $RPM_BUILD_ROOT%{_localedir}/*/LC_MESSAGES/messages.mo; do
	lang=$(echo $file|%{__sed} 's:.*locale/\(.*\)/LC_MESSAGES.*:\1:')
	mv $RPM_BUILD_ROOT%{_localedir}/$lang/LC_MESSAGES/messages.mo \
	$RPM_BUILD_ROOT%{_localedir}/$lang/LC_MESSAGES/%{name}.mo
done;
for file in $RPM_BUILD_ROOT%{_localedir}/*/LC_MESSAGES/iso639.mo; do
	lang=$(echo $file|%{__sed} 's:.*locale/\(.*\)/LC_MESSAGES.*:\1:')
	mv $RPM_BUILD_ROOT%{_localedir}/$lang/LC_MESSAGES/iso639.mo \
	$RPM_BUILD_ROOT%{_localedir}/$lang/LC_MESSAGES/%{name}_iso639.mo
done;

%{__rm} $RPM_BUILD_ROOT%{_bindir}/%{name}-uninstall

# unsupported
%{__rm} -r $RPM_BUILD_ROOT%{_localedir}/ber
%{__rm} -r $RPM_BUILD_ROOT%{_localedir}/jv
%{__rm} -r $RPM_BUILD_ROOT%{_localedir}/ltg
%{__rm} -r $RPM_BUILD_ROOT%{_localedir}/en_AU

install %{SOURCE2} $RPM_BUILD_ROOT%{_bindir}

%find_lang %{name} --all-name

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_desktop_database
%update_mime_database
%update_icon_cache hicolor

%postun
if [ $1 -eq 0 ] ; then
	%update_desktop_database
	%update_mime_database
	%update_icon_cache hicolor
fi

%files -f %{name}.lang
%defattr(644,root,root,755)
%doc Changelog.yaml COPYRIGHT README.md
%attr(755,root,root) %{_bindir}/calibre
%attr(755,root,root) %{_bindir}/calibre-complete
%attr(755,root,root) %{_bindir}/calibre-customize
%attr(755,root,root) %{_bindir}/calibre-debug
%attr(755,root,root) %{_bindir}/calibre-mount-helper
%attr(755,root,root) %{_bindir}/calibre-parallel
%attr(755,root,root) %{_bindir}/calibre-server
%attr(755,root,root) %{_bindir}/calibre-smtp
%attr(755,root,root) %{_bindir}/calibredb
%attr(755,root,root) %{_bindir}/ebook-convert
%attr(755,root,root) %{_bindir}/ebook-device
%attr(755,root,root) %{_bindir}/ebook-edit
%attr(755,root,root) %{_bindir}/ebook-meta
%attr(755,root,root) %{_bindir}/ebook-polish
%attr(755,root,root) %{_bindir}/ebook-viewer
%attr(755,root,root) %{_bindir}/fetch-ebook-metadata
%attr(755,root,root) %{_bindir}/lrf2lrs
%attr(755,root,root) %{_bindir}/lrfviewer
%attr(755,root,root) %{_bindir}/lrs2lrf
%attr(755,root,root) %{_bindir}/markdown-calibre
%attr(755,root,root) %{_bindir}/web2disk
%{_datadir}/%{name}
%{_libdir}/%{name}
%{_desktopdir}/calibre-ebook-edit.desktop
%{_desktopdir}/calibre-ebook-viewer.desktop
%{_desktopdir}/calibre-gui.desktop
%{_desktopdir}/calibre-lrfviewer.desktop
%{_iconsdir}/hicolor/*/*/*.png
%{_datadir}/mime/application/*.xml
%{_datadir}/mime/text/*.xml
%{_datadir}/mime/packages/calibre-mimetypes.xml
%{_pixmapsdir}/%{name}-gui.png
%{_pixmapsdir}/calibre-viewer.png

%files -n bash-completion-calibre
%defattr(644,root,root,755)
%{_sysconfdir}/bash_completion.d/*

%files -n zsh-completion-calibre
%defattr(644,root,root,755)
%{_datadir}/zsh/site-functions/*
%changelog
* Mon Dec 16 2013 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/calibre.git;a=log;h=master

* Mon Dec 16 2013 Artur Frysiak <artur@frysiak.net> 9ada645
- %files fix, release 2

* Sun Dec 15 2013 Artur Frysiak <artur@frysiak.net> 250b7e2
- Up to 1.15.0

* Mon Dec 09 2013 Artur Frysiak <artur@frysiak.net> 2d44714
- Up to 1.14.0

* Sat Dec 07 2013 Artur Frysiak <artur@frysiak.net> a93a85f
- Up to 1.13.0

* Sat Nov 23 2013 Artur Frysiak <artur@frysiak.net> 91cd559
- Up to 1.12.0

* Fri Nov 15 2013 Artur Frysiak <artur@frysiak.net> 9f1cfc6
- Up to 1.11.0

* Sat Nov 02 2013 Artur Frysiak <artur@frysiak.net> d0ce7db
- Up to 1.9.0

* Fri Nov 01 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> e1e2e8d
- release 2 (by relup.sh)

* Sun Oct 27 2013 Artur Frysiak <artur@frysiak.net> 11b4567
- Up to 1.8.0

* Thu Oct 24 2013 Artur Frysiak <artur@frysiak.net> 292858f
- Up to 1.7.0

* Sun Oct 13 2013 Artur Frysiak <artur@frysiak.net> 9db9fce
- Up to 1.6.0

* Sat Sep 28 2013 Artur Frysiak <artur@frysiak.net> bf629b7
- Up to 1.5.0

* Sun Sep 22 2013 Artur Frysiak <artur@frysiak.net> 0f2b815
- Release 3

* Sun Sep 22 2013 Artur Frysiak <artur@frysiak.net> 141d57d
- Fix copy&paste errors

* Sun Sep 22 2013 Artur Frysiak <artur@frysiak.net> 824729a
- Fix bash completion, add zsh completion, release 2

* Sat Sep 21 2013 Artur Frysiak <artur@frysiak.net> 2eeb7ef
- Up to 1.4.0

* Fri Sep 13 2013 Artur Frysiak <artur@frysiak.net> 177ff65
- Up to 1.3.0

* Tue Sep 03 2013 Jan Palus <jan.palus@gmail.com> bd9bec1
- calibre requires one of recent versions of python-apsw

* Tue Sep 03 2013 Jan Palus <jan.palus@gmail.com> a6ec571
- add missing QtCore/QtDBus BRs

* Tue Sep 03 2013 Artur Frysiak <artur@frysiak.net> 35b4fa3
- Up to 1.1.0

